_AUTO_RELOAD_DEBUG = true

print("crush started...")

local values = { 2, 4, 6, 8, 10, 12, 14 }
local value = 12
local LEFT = renoise.SampleBuffer.CHANNEL_LEFT
local RIGHT = renoise.SampleBuffer.CHANNEL_RIGHT

renoise.tool():add_menu_entry {
    name = "Sample Editor:erroreyes:crush...",
    invoke = function() 
        show_dialog()
    end
}

function crush(sample)
    local bits = math.pow(2, value)
    local sample_scaled = bits * (0.5 * sample + 0.5)
    local sample_rounded = math.floor(sample_scaled)
    local out = 2 * (sample_rounded / bits) - 1
    return out
end

-- Adds silence to current sample
function process()
    print("process function called")
    local buffer = renoise.song().selected_sample.sample_buffer
    local sr = buffer.sample_rate
    local bd = buffer.bit_depth
    local nc = buffer.number_of_channels
    local nf = buffer.number_of_frames
    
    print("number_of_frames", nf)

    -- Temp table to hold the original sample data
    local tmpL = {}
    local tmpR = {}

    -- Save buffer to temp table
    for i = 1, nf do
        tmpL[i] = crush(buffer:sample_data(LEFT, i))
        if nc == 2 then
            tmpR[i] = crush(buffer:sample_data(RIGHT, i))
        end
    end

    -- Remove sample data from the buffer and set it with the orignal
    -- buffer's properties.
    buffer:create_sample_data(sr, bd, nc, nf)

    -- Prepare the buffer for new sample data;
    buffer:prepare_sample_data_changes()

    -- Set sample data from the temp table to the current buffer;
    for i = 1, nf do
        buffer:set_sample_data(LEFT, i, tmpL[i])
        if nc == 2 then buffer:set_sample_data(RIGHT, i, tmpR[i]) end     
    end
    
    -- Finalize the buffer.
    buffer:finalize_sample_data_changes()
end

-- Dialog
show_dialog = function()
    local DIALOG_MARGIN = renoise.ViewBuilder.DEFAULT_DIALOG_MARGIN
    local CONTENT_SPACING = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING
    local vb = renoise.ViewBuilder()

    local prompt = renoise.app():show_custom_dialog(
        "CRUSH!",

        vb:column {
            margin = DIALOG_MARGIN, 
            spacing = CONTENT_SPACING,
            vb:row {
                vb:text {
                    text = "bit depth", 
                    width = 80
                },

                vb:popup {
                    tooltip = "Number of bits to reduce to.", 
                    width = 80,
                    items = { "2", "4", "6", "8", "10", "12", "14" }, 
                    value = 6, 
                    notifier = function(i)
                        print("item = "..i)
                        value = values[i]
                    end
                }
            },

            vb:button {
                tooltip = "bit crushes the sample.", 
                text = "CRUSH!", 
                notifier = function()
                    local co = coroutine.create( process )
                    coroutine.resume( co )
                end
            }
        }
    )
end
